#pragma once

#include <vector>
#include <string>

#include "CnvHankakuZenkaku.h"
#include "OnigRegex.h"

#include "ls11_mod.h"
#include "DotNetTestToMultiByte.h"


using namespace System;
using namespace System::Text;
using namespace System::Drawing;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;
using namespace System::Text::RegularExpressions;


char *szBushouTargetFileName = "bfile.n6p";

// 傤 vBufBushouDecodedData[0]=PԖڂ̕t@C̃f[^AvBufBushouDecodedData[1]=QԖڂ̕t@C̃f[^A݂Ȋ
vector<vector<byte>> vBufBushouDecodedData;


ref class BushouData {
public:
	List<String^>^ lstStrFullName; // 
	List<String^>^ lstStrRubyYomi; // ݂
	List<String^>^ lstStrBornEtc;  // N
	List<String^>^ lstStrRetsuden; // `

public:
	BushouData() {
		lstStrFullName = gcnew List<String^>();
		lstStrRubyYomi = gcnew List<String^>();
		lstStrBornEtc  = gcnew List<String^>();
		lstStrRetsuden = gcnew List<String^>();

		BushouData_Import();
	}

	//  u
	std::string StrReplace( std::string String1, std::string String2, std::string String3 )
	{
		std::string::size_type  Pos( String1.find( String2 ) );

		while( Pos != std::string::npos )
		{
			String1.replace( Pos, String2.length(), String3 );
			Pos = String1.find( String2, Pos + String3.length() );
		}

		return String1;
	}

	std::string HankakuKatakanaToZentakuKatakana(std::string szBufOriginal) {

		std::string szBufCurrent = szBufOriginal;

		Matches matches;

		// ̓ȋL͓VċLɂāApJ^JiSpJ^JiɂƂӖ
		for (int i=0; OnigMatch(szBufCurrent, "^(.*?)\x1b\x4b(.*?)\x1b\x48(.*?)$", &matches) && i<(int)szBufCurrent.size(); i++ ) { 
			// `vf𒊏oB
			if ( !matches[2].empty() ) {
				char szBufZenKatakana[256] = "";
				hankana2zenkana((unsigned char *)matches[2].c_str(), (unsigned char *)szBufZenKatakana);
				szBufZenKatakana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				szBufCurrent = matches[1] + szBufZenKatakana + matches[3];
			}
		}

		// Ō̕LȂ܂܍s}ꍇB
		if ( OnigMatch(szBufCurrent, "^(.*?)\x1b\x4b(.+)$", &matches) ) {

			// `vf𒊏oB
			if ( !matches[2].empty() ) {
				char szBufZenKatakana[256] = "";
				hankana2zenkana((unsigned char *)matches[2].c_str(), (unsigned char *)szBufZenKatakana);
				szBufZenKatakana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				szBufCurrent = matches[1] + szBufZenKatakana;
			}
		}

		return szBufCurrent;

	}

	// OnUnmanagedManagedւƒoB
	void NameAssignManagedData(char *pUnmanagedLine) {
		string line = string(pUnmanagedLine);
		Matches matches;
		if ( OnigMatch(line, "^(.*?) \x1b\x6b(.*?)\x1b\x48 (.*?)\x05\x05\x05$", &matches) ) {

			// ]䕔ƍ@䕔̓ʏ
			matches[1] = StrReplace(matches[1], "\xEC\x8C\xEC\x8D\xEC\x8E", "@䕔" );
			matches[1] = StrReplace(matches[1], "\xEC\x8F\xEC\x8D\xEC\x8E", "@䕔" );

			// pˑSp
			char szBufZenKatakana[256] = "";
			hankana2zenkana((unsigned char *)matches[1].c_str(), (unsigned char *)szBufZenKatakana);
			szBufZenKatakana[255] = NULL; // ȏCĂ\Ȃ悤Ô

			String^ strFullName = gcnew String(szBufZenKatakana);
			lstStrFullName->Add( strFullName );

			String^ strRubyYomi = gcnew String(matches[2].c_str());
			lstStrRubyYomi->Add( strRubyYomi );

			String^ strBornEtc  = gcnew String(matches[3].c_str());
			lstStrBornEtc->Add( strBornEtc );
		}
	}

	// Addłł͂ȂāA㏑š Ђǂ\[XɂȂĂorz
	BOOL NameOverrideManagedData(char *pUnmanagedLine, int iSelectedIndex) {
		string line = string(pUnmanagedLine);
		Matches matches;
		if ( OnigMatch(line, "^(.*?) \x1b\x6b(.*?)\x1b\x48 (.*?)\x05\x05\x05(.*?)\x05\x05\x05$", &matches) ) {
			// ]䕔ƍ@䕔̓ʏ
			matches[1] = StrReplace(matches[1], "\xEC\x8C\xEC\x8D\xEC\x8E", "@䕔" );
			matches[1] = StrReplace(matches[1], "\xEC\x8F\xEC\x8D\xEC\x8E", "@䕔" );

			// IĂƂɏ㏑
			String^ strFullName = gcnew String(matches[1].c_str());
			lstStrFullName[iSelectedIndex] = strFullName;

			String^ strRubyYomi = gcnew String(matches[2].c_str());
			lstStrRubyYomi[iSelectedIndex] = strRubyYomi;

			String^ strBornEtc  = gcnew String(matches[3].c_str());
			lstStrBornEtc[iSelectedIndex] = strBornEtc;

			return TRUE;
		}
		return FALSE;
	}

	// `nUnmanagedManagedւƒoB
	String^ RetsudenAssignManagedData(char *pUnmanagedLine) {

		string szBufCurrent = string(pUnmanagedLine);

		szBufCurrent = HankakuKatakanaToZentakuKatakana(szBufCurrent);

		Matches matches;

		// Ō̏ILȍ~͏B
		if ( OnigMatch(szBufCurrent, "^(.*?)\x05\x05\x05$", &matches) ) {

			if ( !matches[1].empty() ) {
				// ćApJ^JiSpЂ炪Ȃ
				char szBufZenHiragana[256] = "";
				hankana2zenhira((unsigned char *)matches[1].c_str(), (unsigned char *)szBufZenHiragana);
				szBufZenHiragana[255] = NULL; // ȏCĂ\Ȃ悤Ô

				string strZenHiragana = string(szBufZenHiragana);

				// sIӖ̂̂ȋLɒuB̂߁B
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)\n(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "<r><n>" + matches[2];
					}
				}

				// ȋLA`GfB^ł̌ڂ̉sւƕϊB
				for (int i=0; OnigMatch(strZenHiragana, "^(.*?)<r><n>(.+)", &matches) && i<(int)strZenHiragana.size(); i++ ) { 
					// `vf𒊏oB
					if ( !matches[1].empty() ) {
						strZenHiragana = matches[1] + "\r\n" + matches[2];
					}
				}
				return gcnew String(strZenHiragana.c_str());
			}
		}

		return gcnew String("");
	}



	// bfile.n6pzւƊi[B
	int BushouData_Import() {
		if (! System::IO::File::Exists( gcnew String(szBushouTargetFileName) ) ) {
			System::Windows::Forms::MessageBox::Show(gcnew String(szBushouTargetFileName)+"ǂݍ߂܂", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
		}

		// kꂽLS11tH[}bgfR[h֐
		ls11_DecodePack(szBushouTargetFileName, NULL, &vBufBushouDecodedData );

		int iRetsudenNo = -1;

		// fR[hf[^(I)t@Cł܂킵ĂB0Ԃ͑Ώۂł͂ȂBf[^1ԂB
		int ivBufDecodedDataSize = vBufBushouDecodedData.size();

		// 1ԖڂX^[gĂ!! !!
		for ( int ifile = 1; ifile < (int)ivBufDecodedDataSize ; ifile++ ) {

			// 傤 vSplittedData[0]=PԖڂ̗vf̃f[^AvSplittedData[1]=QԖڂ̗vf̃f[^A݂Ȋ
			vector<vector<byte>> vSplittedData;

			ls11_SplitData( vBufBushouDecodedData[ifile], &vSplittedData );

			int ivSplittedDataSize = vSplittedData.size();

			// evfƂɥ ܂OAǂ݉ vN̗
			for ( int ielem=0; ielem < (int)ivSplittedDataSize; ielem++ ) {
				if ( ielem%2==0 ) { iRetsudenNo++; }

				if ( iRetsudenNo < 0 ) { iRetsudenNo = 0; }; // ň̂߂̔ԕ

				// ǂ݉Ƃ
				if ( ielem%2==0 ) {

					int datasize = vSplittedData[ielem].size();
					if ( datasize > 0 ) {

						char *bytedata = new char[datasize+1];
						memcpy( bytedata, &vSplittedData[ielem][0], datasize );
						bytedata[datasize] = NULL; // ԕ

						NameAssignManagedData( bytedata ); // }l[Whf[^ւƑ

						delete bytedata;
					}


				// ͗`B
				} else { 

					string szBufCurrent;

					int datasize = vSplittedData[ielem].size();
					if ( datasize > 0 ) {

						char *bytedata = new char[datasize+1];
						memcpy( bytedata, &vSplittedData[ielem][0], datasize );
						bytedata[datasize] = NULL; // ԕ
						szBufCurrent = string(bytedata); 

						String^ strRetsuden = RetsudenAssignManagedData( bytedata ); // }l[Whf[^ւƑ
						lstStrRetsuden->Add( strRetsuden );

						delete bytedata;
					}

				}
			}
		}

		// v`ԂB
		return iRetsudenNo+1;
	}

	// ƂPl̕f[^̏o͗poCif[^𓾂
	std::string GetOneBushouExportData(int iSelectedIndex) {
		String^ managedData = String::Format("{0} \x1b\x6b{1}\x1b\x48 {2}\x05\x05\x05{3}\x05\x05\x05", lstStrFullName[iSelectedIndex], lstStrRubyYomi[iSelectedIndex], lstStrBornEtc[iSelectedIndex], lstStrRetsuden[iSelectedIndex]);

		return GetOutputFormatNormalizeData(managedData);

	}

	std::string GetOutputFormatNormalizeData(String^ managedData) {
		// .NET^CvString^  }`oCgC++^std::string
		std::string unmanagedData = DotNetStringToMultiByte(managedData);

		Matches matches;
		// ȋLA`GfB^ł̌ڂ̉sւƕϊB
		for (int i=0; OnigMatch(unmanagedData, "^(.*?)\r\n(.+)", &matches) && i<(int)unmanagedData.size(); i++ ) { 
			// `vf𒊏oB
			if ( !matches[1].empty() ) {
				unmanagedData = matches[1] + "\x0A" + matches[2];
			}
		}

		return unmanagedData;
	}

	// ƂPl̕f[^t@C
	BOOL GetOneBushouImportData(String^ managedFilePath, int iSelectedIndex) {
		std::string unmanagedFilePath = DotNetStringToMultiByte(managedFilePath);

		FILE *fp = fopen( unmanagedFilePath.c_str(), "rb");
		if ( fp ) {
			char pUnmanagedLine[512] = "";
			fread( pUnmanagedLine, sizeof(pUnmanagedLine)-1, 1, fp); // Cɓǂݍ
			fclose(fp);


			string line = string(pUnmanagedLine);
			Matches matches;
			if ( OnigMatch(line, "^(.*?) \x1b\x6b(.*?)\x1b\x48 (.*?)\x05\x05\x05(.*?\x05\x05\x05$)", &matches) ) {

				BOOL ret1 = NameOverrideManagedData(pUnmanagedLine, iSelectedIndex);

				if (!ret1) {
					System::Windows::Forms::MessageBox::Show("f[^̎捞Ɏs܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
					return FALSE;
				}

				// `n
				String^ strRetsuden = RetsudenAssignManagedData((char *)matches[4].c_str());

				lstStrRetsuden[iSelectedIndex] = strRetsuden;

				System::Windows::Forms::MessageBox::Show("f[^荞݂܂BB", "", MessageBoxButtons::OK, ::MessageBoxIcon::Information);
				return TRUE;
			}

		} else {
			System::Windows::Forms::MessageBox::Show("t@C̃I[vɎs܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
			return FALSE;
		}

		return FALSE;
	}

	BOOL AllSaveToBFileN6P() {
		// PԖڂ̃f[^͎c
		vector<byte> vFirstData = vBufBushouDecodedData[0];
		vBufBushouDecodedData.clear(); // [S
		vBufBushouDecodedData.push_back( vFirstData ); // FirstDataZbeBO

		// `SĂɂĥ
		int iFileCnt = lstStrFullName->Count / 50; // zt@C()JEgBP50Ȃ̂ŁB

		// ꂼ̕ԍ̊Jnԍ𑗂ȂAzt@Ct@CJԂBvBufBushouDecodedData ɕtĂ䂭B
		for ( int f=0; f<iFileCnt; f++) {
			MakeSplittedDataToJoindData( f*50 );
		}

		// pbNC[W
		int result = ls11_EncodePack( szBushouTargetFileName, NULL, &vBufBushouDecodedData );

		if ( result == 0 ) {
			System::Windows::Forms::MessageBox::Show( gcnew String(szBushouTargetFileName) + "ւƏo͂܂B", "", MessageBoxButtons::OK, ::MessageBoxIcon::Information);
			return TRUE;
		} else {
			System::Windows::Forms::MessageBox::Show( "\ʃG[܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
			return FALSE;
		}
	}

	// P̉zt@C(ꂽ̑)ɍoB
	void MakeSplittedDataToJoindData(int iStartIndex) {
		vector<vector<byte>> vSplittedData; // 50 lł䂭f[^
		vector<byte> vDstJoinedData; // 50 lł䂭f[^

		// 50l
		for ( int i=iStartIndex; (i < iStartIndex + 50) && (i < lstStrFullName->Count); i++ ) {
			vSplittedData.push_back( GetNameLineData(i) );
			vSplittedData.push_back( GetRetsudenLineData(i) );
		}

		// ̂ւƖ߂BPt@C
		ls11_JoinData(vSplittedData, &vDstJoinedData);

		// S̃f[^ɉB
		vBufBushouDecodedData.push_back( vDstJoinedData );
	}

	// ƂPl̖̕ONñf[^
	vector<byte> GetNameLineData(int iTargetIndex) {

		String^ format = String::Format("{0} \x1b\x6b{1}\x1b\x48 {2}\x05\x05\x05", lstStrFullName[iTargetIndex], lstStrRubyYomi[iTargetIndex], lstStrBornEtc[iTargetIndex]);

		std::string unmanagedData = GetOutputFormatNormalizeData(format);

		char *psz = (char *)unmanagedData.c_str();

		// Cchar[]vector<byte>ւƃRs[
		vector<byte> line( &psz[0], &psz[strlen(psz)] );

		return line;
	}

	// Ƃ1l̗̕`Ł[
	vector<byte> GetRetsudenLineData(int iTargetIndex) {
		String^ format = String::Format("{0}\x05\x05\x05", lstStrRetsuden[iTargetIndex]);

		std::string unmanagedData = GetOutputFormatNormalizeData(format);

		char *psz = (char *)unmanagedData.c_str();

		// Cchar[]vector<byte>ւƃRs[
		vector<byte> line( &psz[0], &psz[strlen(psz)] );

		return line;

	}

};